%define realname check_mk
%define name nagios-%{realname}
%define version	1.2.3i1
%define release	%mkrel 3
%define _requires_exceptions pear(default.php)

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	A collection of extensions for the IT-Monitoring-Kernel of Nagios
Group:		Networking/Other
License:	BSD
URL:		http://mathias-kettner.com/check_mk.html
Source0:	http://mathias-kettner.de/download/%{realname}-%{version}.tar.gz
Source1:	check_mk_objects.cfg
Patch1:		check_mk_systemd.patch
BuildArch:	noarch
Provides:	check_mk
Requires:	nagios
Requires:	nagios-check_icmp
Suggests:	systemd-check_mk_agent
Suggests:	%{name}-multisite
Suggests:	mk-livestatus
suggests:	pnp4nagios
Conflicts:	nagios-localhost

%description
Check_MK is a collection of extensions for the IT-Monitoring-Kernel of Nagios
and together with this, and ideally also with PNP4Nagios and NagVis constitutes
a complete IT-Monitoring-System. It adopts a new approach for collecting data
from operating systems and network components. It obsoletes NRPE, check_by_ssh,
NSClient, and check_snmp and it has many benefits, the most important of which
are significant reduction of CPU usage on the Nagios host and automatic
inventory of items to be checked on hosts. The larger your Nagios installation
is, the more helpful these improvements.

%package agent
Summary:    Agent for check_mk
Group:      Networking/Other

%description agent
This package contains the agent for check_mk. Install this on all Linux
machines you want to monitor via check_mk.

%package multisite
Summary:    Multisite for check_mk
Group:      Networking/Other
Requires:   apache
Requires:   apache-mod_python-compat
Requires:   %{name}
Suggests:   mk-livestatus
suggests:   pnp4nagios

%description multisite
This package containst the multisite for check_mk. Install this if you wish to
use a webfrontend that's well integrated with check_mk.

%package doc
Summary:    Documentation for check_mk
Group:      Networking/Other

%description doc
This package contains the documentation for check_mk.

%package localhost
Summary:    default localhost check_mk checks
Conflicts:  nagios-localhost

%description localhost
This includes default check_mk checks for localhost

%package -n xinetd-check_mk_agent
Summary:    xinetd check_mk_agent configuration
Requires:   xinetd
Requires:   %{name}-agent
Group:      Networking/Other
Conflicts:  systemd-check_mk_agent

%description -n xinetd-check_mk_agent
This package contains the xinetd configuration for check_mk.

%package -n systemd-check_mk_agent
Summary:    systemd check_mk_agent configuration
Requires:   systemd
Requires:   %{name}-agent
Group:      Networking/Other
Conflicts:  xinetd-check_mk_agent

%description -n systemd-check_mk_agent
This package contains the systemd configuration for check_mk.

%prep
%setup -q -n check_mk-%{version}
tar xf agents.tar.gz
tar xf conf.tar.gz
tar xf share.tar.gz

%build

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_bindir}
cat > %{buildroot}%{_bindir}/check_mk <<'EOF'
#!/bin/sh
exec python %{_datadir}/check_mk/modules/check_mk.py "$@"
EOF

chmod +x %{buildroot}%{_bindir}/check_mk
ln -s %{_bindir}/check_mk %{buildroot}%{_bindir}/cmk

## conf
# redoing default main.mk
install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk
install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk/conf.d
cat > %{buildroot}%{_sysconfdir}/check_mk/main.mk <<'EOF'
monitoring_host = 'localhost'
all_hosts = [
	'localhost|tcp',
]
EOF

# install multisite.mk
install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk/multisite.d
install -D -m 644 multisite.mk-%{version} %{buildroot}%{_sysconfdir}/check_mk/multisite.mk

# wato
install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk/conf.d/wato
install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk/multisite.d/wato
cat > %{buildroot}%{_sysconfdir}/check_mk/conf.d/wato/contacts.mk <<'EOF'
EOF
cat > %{buildroot}%{_sysconfdir}/check_mk/multisite.d/wato/users.mk <<'EOF'
EOF

## modules

install -d -m 755 %{buildroot}%{_datadir}/check_mk
install -d -m 755 %{buildroot}%{_datadir}/check_mk/modules
tar xf modules.tar.gz -C %{buildroot}%{_datadir}/check_mk/modules

## patch check_mk
pushd %{buildroot}%{_datadir}/check_mk
%apply_patches
popd

# nagios templates
sed -i check_mk_templates.cfg -E \
-e 's,@PNPURL@,/pnp4nagios/,g' \
-e 's,@CGIURL@,/nagios/cgi-bin,g' \
-e 's,@VARDIR@,%{_localstatedir}/lib/check_mk,g' \
-e 's,@BINDIR@,%{_bindir},g' \
-e 's,@CHECK_ICMP@,%{_libdir}/nagios/plugins/check_icmp,g' \
-e 's,'"' class='tips' rel='"'," class="tips" rel=",g'
install -d -m 755 %{buildroot}%{_sysconfdir}/nagios/plugins.d/
install -D -m 644 check_mk_templates.cfg %{buildroot}%{_sysconfdir}/nagios/plugins.d/
install -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/nagios/plugins.d/

install -d -m 755 %{buildroot}%{_datadir}/check_mk/checks
tar xf checks.tar.gz -C %{buildroot}%{_datadir}/check_mk/checks
install -d -m 755 %{buildroot}%{_datadir}/check_mk/web
tar xf web.tar.gz -C %{buildroot}%{_datadir}/check_mk/web
install -d -m 755 %{buildroot}%{_datadir}/check_mk/pnp-templates
tar xf pnp-templates.tar.gz -C %{buildroot}%{_datadir}/check_mk/pnp-templates

install -d -m 755 %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
cat > %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/check_mk.conf <<'EOF'
Alias /check_mk %{_datadir}/check_mk/web/htdocs
<Directory %{_datadir}/check_mk/web/htdocs>
	DirectoryIndex index.py
	SetEnv PythonHandler index
	AuthType Basic
	AuthName "Monitoring Access (default is nagiosadmin/nagiosadmin)"
	AuthUserFile %{_sysconfdir}/nagios/passwd
	Require valid-user
</Directory>
EOF

cat > %{buildroot}%{_datadir}/check_mk/modules/defaults <<'EOF'
# created during package creation

check_mk_version            = '%{version}'
default_config_dir          = '%{_sysconfdir}/check_mk'
check_mk_configdir          = '%{_sysconfdir}/check_mk/conf.d'
checks_dir                  = '%{_datadir}/check_mk/checks'
check_manpages_dir          = '%{_datadir}/check_mk/doc/checks'
modules_dir                 = '%{_datadir}/check_mk/modules'
agents_dir                  = '%{_datadir}/check_mk/agents'
var_dir                     = '%{_localstatedir}/lib/check_mk'
tmp_dir                     = '%{_localstatedir}/tmp'
lib_dir                     = ''
autochecksdir               = '%{_localstatedir}/lib/check_mk/autochecks'
precompiled_hostchecks_dir  = '%{_localstatedir}/lib/check_mk/precompiled'
counters_directory          = '%{_localstatedir}/lib/check_mk/counters'
tcp_cache_dir               = '%{_localstatedir}/lib/check_mk/cache'
logwatch_dir                = '%{_localstatedir}/lib/check_mk/logwatch'
nagios_objects_file         = '%{_sysconfdir}/nagios/plugins.d/check_mk_objects.cfg'
rrd_path                    = '%{_localstatedir}/lib/check_mk/rrd'
check_result_path           = '%{_localstatedir}/spool/nagios/checkresults'
nagios_command_pipe_path    = '%{_localstatedir}/spool/nagios/nagios.cmd'
nagios_status_file          = '%{_localstatedir}/log/nagios/status.dat'
nagios_conf_dir             = '%{_sysconfdir}/nagios/plugins.d'
nagios_user                 = 'nagios'
nagios_url                  = '/nagios'
nagios_cgi_url              = '/nagios/cgi-bin'
logwatch_notes_url          = '/check_mk/logwatch.py?host=%s&file=%s'
www_group                   = 'apache'
nagios_config_file          = '%{_sysconfdir}/nagios/.nagios.cfg'
nagios_startscript          = None
nagios_startuptype          = 'systemctl'
nagios_service              = 'nagios.service'
nagios_binary               = '%{_sbindir}/nagios'
apache_config_dir           = '%{_sysconfdir}/httpd/conf/webapps.d'
htpasswd_file               = '%{_sysconfdir}/nagios/passwd'
nagios_auth_name            = 'Monitoring Access (default is nagiosadmin/nagiosadmin)'
web_dir                     = '%{_datadir}/check_mk/web'
checkmk_web_uri             = '/check_mk'
livestatus_unix_socket      = '%{_localstatedir}/spool/nagios/live'
livebackendsdir             = ''
url_prefix                  = '/'
pnp_url                     = '/pnp4nagios/'
pnp_templates_dir           = '%{_datadir}/check_mk/pnp-templates'
doc_dir                     = '%{_datadir}/doc/check_mk'
EOF

cp %{buildroot}%{_datadir}/check_mk/modules/defaults \
    %{buildroot}%{_datadir}/check_mk/web/htdocs/defaults.py

install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/autochecks
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/cache
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/counters
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/precompiled
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/logwatch
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/rrd
install -d -m 770 %{buildroot}%{_localstatedir}/lib/check_mk/web
install -d -m 755 %{buildroot}%{_localstatedir}/lib/check_mk/wato

install -d -m 755 %{buildroot}%{_docdir}/%{name}
tar xf doc.tar.gz -C %{buildroot}%{_docdir}/%{name} --exclude livestatus

install -d -m 755 %{buildroot}%{_sysconfdir}/xinetd.d
install -m 644 xinetd.conf %{buildroot}%{_sysconfdir}/xinetd.d/check_mk_agent

install -d -m 755 %{buildroot}%{_unitdir}
cat > %{buildroot}%{_unitdir}/check_mk_agent.socket <<'EOF'
[Unit]
Description=Socket for Check_MK agent

[Socket]
ListenStream=6556
Accept=yes
MaxConnections=5

[Install]
WantedBy=sockets.target
EOF

cat > %{buildroot}%{_unitdir}/check_mk_agent@.service <<'EOF'
[Unit]
Description=Check_MK agent

[Service]
ExecStart=%{_bindir}/check_mk_agent
StandardInput=null
StandardOutput=socket
StandardError=null
EOF

cat > README.install.urpmi <<'EOF'
By default the agent only listens on the lo interface. This has been set in
the %{_sysconfdir}/systemd/system/check_mk_agent.socket.d/bind.conf file. You
should remove or adjust the file when your firewall is properly configured.
EOF

install -d -m 755 %{buildroot}%{_bindir}
install -m 755 check_mk_agent.linux %{buildroot}%{_bindir}/check_mk_agent

install -d -m 755 %{buildroot}%{_datadir}/check_mk_agent
install -d -m 755 %{buildroot}%{_datadir}/check_mk_agent/plugins
install -d -m 755 %{buildroot}%{_datadir}/check_mk_agent/local
install -m 644 plugins/mk_logwatch %{buildroot}%{_datadir}/check_mk_agent/plugins
install -m 644 plugins/j4p_performance %{buildroot}%{_datadir}/check_mk_agent/plugins
install -m 644 plugins/mk_oracle %{buildroot}%{_datadir}/check_mk_agent/plugins
install -m 644 plugins/sylo %{buildroot}%{_datadir}/check_mk_agent/plugins

install -d -m 755 %{buildroot}%{_sysconfdir}/check_mk_agent
install -m 644 logwatch.cfg %{buildroot}%{_sysconfdir}/check_mk_agent

perl -pi \
    -e 's|LIBDIR="/to/be/changed"|LIBDIR="%{_datadir}/check_mk_agent"|;' \
    -e 's|CONFDIR="/to/be/changed"|CONFDIR="%{_sysconfdir}/check_mk_agent"|;' \
    %{buildroot}%{_bindir}/check_mk_agent

%post agent
if [ $1 == 1 ]; then
	mkdir -p %{_sysconfdir}/systemd/system/check_mk_agent.socket.d
	if ! [ -f "%{_sysconfdir}/systemd/system/check_mk_agent.socket.d/bind.conf" ]; then
		cat > %{_sysconfdir}/systemd/system/check_mk_agent.socket.d/bind.conf <<'EOF'
[Socket]
BindToDevice=lo
# remove this file to bind to all interfaces, but make sure you set up the firewall properly
EOF
	fi
	systemctl enable check_mk_agent.socket
	systemctl restart sockets.target
fi

%preun agent
systemctl disable check_mk_agent.socket
systemctl restart sockets.target

%postun agent
if [ $1 == 0 ]; then
	rm -f %{_sysconfdir}/systemd/system/check_mk_agent.socket.d/bind.conf
	rmdir %{_sysconfdir}/systemd/system/check_mk_agent.socket.d 2>/dev/null
fi

%files
%exclude %{_datadir}/check_mk/web
%exclude %{_sysconfdir}/check_mk/multisite.mk
%exclude %{_sysconfdir}/check_mk/multisite.d
%exclude %{_sysconfdir}/check_mk/multisite.d/wato
%exclude %{_sysconfdir}/check_mk/conf.d/wato
%{_bindir}/check_mk
%{_bindir}/cmk
%config(noreplace) %{_sysconfdir}/check_mk
%config(noreplace) %{_sysconfdir}/nagios/plugins.d/check_mk_templates.cfg
%{_datadir}/check_mk
%attr(2770,apache,nagios) %{_localstatedir}/lib/check_mk

%files multisite
%config(noreplace) %{_sysconfdir}/check_mk/multisite.mk
%config(noreplace) %{_sysconfdir}/check_mk/multisite.d
%attr(-,apache,apache) %config(noreplace) %{_sysconfdir}/check_mk/conf.d/wato
%attr(-,apache,apache) %config(noreplace) %{_sysconfdir}/check_mk/multisite.d/wato
%{_datadir}/check_mk/web
%config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/check_mk.conf

%files agent
%{_bindir}/check_mk_agent
%{_datadir}/check_mk_agent
%config(noreplace) %{_sysconfdir}/check_mk_agent

%files localhost
%config(noreplace) %{_sysconfdir}/nagios/plugins.d/check_mk_objects.cfg

%files doc
%doc %{_docdir}/%{name}

%files -n xinetd-check_mk_agent
%config(noreplace) %{_sysconfdir}/xinetd.d/check_mk_agent

%files -n systemd-check_mk_agent
%doc README.install.urpmi
# TODO: comment this for now, since rules need to be changed
#%ghost %{_sysconfdir}/systemd/system/check_mk_agent.conf.d/bind.conf
%{_unitdir}/check_mk_agent.socket
%{_unitdir}/check_mk_agent@.service



%changelog
* Sat Oct 19 2013 umeabot <umeabot> 1.2.3i1-3.mga4
+ Revision: 531169
- Mageia 4 Mass Rebuild

* Fri Aug 02 2013 alien <alien> 1.2.3i1-2.mga4
+ Revision: 462493
- remove the socket override file on uninstall

* Fri Aug 02 2013 alien <alien> 1.2.3i1-1.mga4
+ Revision: 462486
- Put check_mk_agent.socket in unitdir and specify a override file in /etc that binds to the lo interface
- Update to new version
- split off multisite subpackage
- split off doc subpackage
- make a xinetd helper package
- make a systemd helper package
- provide localhost checks in a subpackage (conflicting with nagios-localhost)
- update the defaults
- move config files into proper place
- configure a way for multisite to work with nagios credentials (same as pnp4nagios credentials)
- supply a cmk alias

  + guillomovitch <guillomovitch>
    - new version

* Sat Jan 12 2013 umeabot <umeabot> 1.2.0p3-2.mga3
+ Revision: 360712
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Dec 24 2012 guillomovitch <guillomovitch> 1.2.0p3-1.mga3
+ Revision: 334436
- new version

* Sat Jun 09 2012 guillomovitch <guillomovitch> 1.2.0p1-1.mga3
+ Revision: 258677
- new version

* Thu Sep 08 2011 tv <tv> 1.1.10-1.mga2
+ Revision: 141140
- new release

* Thu Mar 03 2011 ennael <ennael> 1.1.8-1.mga1
+ Revision: 62942
- imported package nagios-check_mk


* Sat Jan 01 2011 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.8-1mdv2011.0
+ Revision: 627149
- update to new version 1.1.8

* Tue Oct 19 2010 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.6p1-3mdv2011.0
+ Revision: 586772
- don't ship livestatus files in documentation

* Wed Aug 11 2010 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.6p1-2mdv2011.0
+ Revision: 569156
- fix executable location and executable bit
- fix some defaults

* Sun Aug 08 2010 Guillaume Rousse <guillomovitch@mandriva.org> 1.1.6p1-1mdv2011.0
+ Revision: 567779
- new version

* Sat Nov 07 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.39-1mdv2010.1
+ Revision: 462355
- new version

* Sun Sep 27 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.37-2mdv2010.0
+ Revision: 450272
- fix dependencies

* Sat Sep 26 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.37-1mdv2010.0
+ Revision: 449294
- new version

* Sat Jul 18 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.34-1mdv2010.0
+ Revision: 396955
- import nagios-check_mk


* Sat Jul 18 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.34-1mdv2010.0
- first mdv package
